// PlotDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Plot.h"
#include "PlotDlg.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPlotDlg dialog

CPlotDlg::CPlotDlg(CWnd* pParent /*=NULL*/)
	: CMovableDialog(CPlotDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPlotDlg)
	m_intStromy = 0;
	m_dblDelka = 0.0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPlotDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPlotDlg)
	DDX_Text(pDX, IDC_STROMY, m_intStromy);
	DDX_Text(pDX, IDC_DELKA, m_dblDelka);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPlotDlg, CDialog)
	//{{AFX_MSG_MAP(CPlotDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_LOAD, OnLoad)
	//}}AFX_MSG_MAP
	ON_WM_GETMINMAXINFO()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPlotDlg message handlers

BOOL CPlotDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	m_ctlGarden.SubclassDlgItem(IDC_ZAHRADA,this);

	InitMovableDialog(IDC_ZAHRADA,true);

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPlotDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPlotDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CPlotDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	ApplyMovableDialog(cx, cy);
}

void CPlotDlg::OnGetMinMaxInfo(MINMAXINFO* lpMMI)
{
	CDialog::OnGetMinMaxInfo(lpMMI);

	CWnd *w;
	if (!(w=GetDlgItem(IDC_CONTROLS))) return;

	CRect rcControls;
	w->GetClientRect(rcControls);	
	lpMMI->ptMinTrackSize.x=rcControls.Width()+128;
	lpMMI->ptMinTrackSize.y=rcControls.Height()+GetSystemMetrics(SM_CYMENU)+GetSystemMetrics(SM_CYCAPTION);
}

#include <algorithm>
bool gardenCmp(const CPoint &a, const CPoint &b) { return a.x < b.x; }

void CPlotDlg::OnLoad() 
{
	UpdateData(TRUE);
	CFileDialog dlg(TRUE,"txt",NULL,OFN_HIDEREADONLY|OFN_EXPLORER|OFN_FILEMUSTEXIST|OFN_NOCHANGEDIR|OFN_PATHMUSTEXIST,"Textov soubory (*.txt)|*.txt|Vechny soubory (*.*)|*.*|",this);	
	if (dlg.DoModal()==IDOK) {
		FILE *fr=fopen(dlg.GetPathName(), "r");
		body.RemoveAll();

		fscanf(fr, "%d", &m_intStromy);
		for (int j=0;j<m_intStromy;j++) {
			int x,y;
			fscanf(fr, "%d %d", &x, &y);
			body.Add(CPoint(x, y));
		}
		fclose(fr);

		std::sort(body.GetData(), body.GetData()+m_intStromy,gardenCmp);
		ComputeCHull();
		UpdateData(FALSE);
		m_ctlGarden.Invalidate();
	}
}

void CPlotDlg::GardenDraw(CDC *pDC, int w, int h)
{
#define CONVERT_X(a) ((a)*w/512)
#define CONVERT_Y(b) ((b)*h/512)
	pDC->FillSolidRect(0,0,w,h,RGB(255,255,255));

	for (int j=0;j<body.GetSize();j++) {
		pDC->FillSolidRect(CONVERT_X(body[j].x)-2,CONVERT_Y(body[j].y)-2,5,5,RGB(0,192,0));
	}

	for (int k=0;k<2;k++) {
		if (obal[k].GetSize()) pDC->MoveTo(CONVERT_X(body[obal[k][0]].x),CONVERT_Y(body[obal[k][0]].y));
		for (int i=1;i<obal[k].GetSize();i++) pDC->LineTo(CONVERT_X(body[obal[k][i]].x),CONVERT_Y(body[obal[k][i]].y));
	}
}

void CPlotDlg::GardenAddTree(int x, int y)
{
	int index=0;
	while (index < body.GetSize() && body[index].x < x) index++;
	body.InsertAt(index,CPoint(x,y));
	m_intStromy++;

	ComputeCHull();
	m_ctlGarden.Invalidate();
	UpdateData(FALSE);
}

void CPlotDlg::GardenDellTree(int x, int y)
{
	for (int step=1;step<6;step+=2)
		for (int j=0;j<body.GetSize();j++)
			if (abs(body[j].x-x) <= step)
				if (abs(body[j].y-y) <= step) {
					body.RemoveAt(j);
					goto deleted;
				}
	return;
deleted:
	m_intStromy--;
	ComputeCHull();
	m_ctlGarden.Invalidate();
	UpdateData(FALSE);
}

void CPlotDlg::ComputeCHull()
{
	obal[0].RemoveAll();
	obal[1].RemoveAll();
	m_dblDelka=0.0;
	if (body.GetSize() <= 1) return;

	for (int k=0;k<2;k++) {
		for (int j=0;j<body.GetSize();j++) {
			obal[k].Add(j);
			while (obal[k].GetSize()>2) {
				int l=obal[k].GetUpperBound();
				int mult=(body[obal[k][l]].x - body[obal[k][l-1]].x)*(body[obal[k][l-2]].y - body[obal[k][l-1]].y)-
					(body[obal[k][l-2]].x - body[obal[k][l-1]].x)*(body[obal[k][l]].y - body[obal[k][l-1]].y);
				if (!k && mult>0) break;
				if (k && mult<0) break;
				obal[k][l-1]=obal[k][l];
				obal[k].RemoveAt(l);
			}
		}
#define SQR(x) ((x)*(x))
		for (int i=1;i<obal[k].GetSize();i++) 
			m_dblDelka+=sqrt(SQR(body[obal[k][i]].x-body[obal[k][i-1]].x)+SQR(body[obal[k][i]].y-body[obal[k][i-1]].y));
	}
}
